#include "common.fx"

SamplerState SampleType;

#define DIFFUSE_MAP 0
#define NORMAL_MAP 1

Texture2D shaderTextures[2] : register( t1 );

Texture2D shadowMaskMap : register( t4 );

cbuffer ObjectBufferCustom : register(b5) 
{
	float4 myCustomData;
};

float4 PShader(PixelInputType input) : SV_TARGET
{
	float4 Diffuse = shaderTextures[DIFFUSE_MAP].Sample(SampleType, input.tex) * input.color;
	
	#ifdef USE_NOISE
	float4 noise = myNoiseTexture.Sample(SampleType, input.tex); 
	#endif
	
	float3 AmbientColor = Diffuse.xyz * myAmbience;
	float3 DirectColor = float3(0, 0, 0);
	
					/*
					#ifdef USE_LIGHTS
					float3 Normal = normalize((shaderTextures[NORMAL_MAP].Sample(SampleType, input.tex).xyz * 2.0f) - 1.0f);
					float2 Resolution = myResolution.xy;
					for (unsigned int index = 0; index < myNumberOfLights; index++)
					{
						float Intensity = myLights[index].myPosition.z;
						float Falloff = myLights[index].myPosition.w;

						float2 difference = float2((myLights[index].myPosition.xy - input.position.xy) / Resolution.xy);
						difference.x *= (Resolution.x / Resolution.y);
						difference.y *= -1; 

						float distance = length(difference); 

						float linearAttenuation = saturate((Falloff - distance) / Falloff);
						float physicalAttenuation = 1.0f/(1.0f + distance);
						float totalAttenuation = linearAttenuation * physicalAttenuation;

						float3 direction = normalize(float3(difference.xy, (Falloff / 2)));

						float lambert = dot(direction, Normal); 

						DirectColor += Diffuse.xyz * Intensity * totalAttenuation * myLights[index].myLightColor.xyz * lambert;
						
					} 
					#endif
					*/
	
	
	/*
		Since the visibility mask sprite texture is of size 320x180 at the moment 
		(I am unable to get it to 256x256 for some god damn reason dude.)
		
		But, therefore we have to remap the texture coordinates in here to 
		make the visibility mask fit into the 256x256 light texture.
	*/
	
	const int lightIndex = (int)myCustomData.z;
	
	const float lightScaleX = myCustomData.x;
	const float lightScaleY = myCustomData.y;
	
	const float visiblityMaskSpriteWidth = 320.f * lightScaleX;
	const float visiblityMaskSpriteHeight = 180.f * lightScaleY;
	
	// The target sprite we are masking the visibility mask to
	const float lightSpriteWidth = 256 * lightScaleX;
	const float lightMaskSpriteHeight = 256 * lightScaleY;
	
	float widthVal = lightSpriteWidth / visiblityMaskSpriteWidth;
	float heightVal = lightMaskSpriteHeight / visiblityMaskSpriteHeight;
	
	float newX1 = lerp(0.f, widthVal, input.tex.x);
	
	// 1.f - because we flip the Y axis upside down due to Sprites being +Y down, but my camera +Y being up
	float newY1 = lerp(0.f, heightVal, 1.f - input.tex.y);
	
	// WHAT A FUCKIN MESS BRUH, whatever..
	
	// A value that is 0 or 1 based on the visibility
	float maskValue = shadowMaskMap.Sample(SampleType, 
		float2(
			newX1 + (1.f - widthVal) * 0.5f, 
			newY1 + (1.f - heightVal) * 0.5f)).r;
	
	//float maskValue = shadowMaskMap.Sample(SampleType, input.tex).r;
	
	return float4((AmbientColor + DirectColor) * maskValue, Diffuse.w * maskValue);
	
	//return float4(maskValue, maskValue, maskValue, 1.f);
	
	// return float4(AmbientColor + DirectColor, Diffuse.w);
}